XXOR - Editorial

PROBLEM LINK:

Div1, Div2

Practice

Author: Hruday Pabbisetty

Tester: Triveni Mahatha

Editorialist: Adarsh Kumar

DIFFICULTY:

Easy-Medium

PREREQUISITES:

Prefix Sum

PROBLEM:

You are given an array with N elements. You need to answer Q queries. In each query, you are given two parameters L and R, and you have to find the smallest integer X such that 0 \le X < 2^{31} and the value of \sum \limits_{i=L}^R (A[i]\text{ xor }X) is maximum possible.

EXPLANATION:

Lets focus on the binary representation of each A[i]'s and X. You can observe that each bit are independent, i.e. you can solve the same problem by iterating over each bit. Basically, for each bit you can reduce the problem to simpler one.

Given a binary array P of length N. And in each query, you need to find minimum X where 0 \le X \le 1 and the value of G(L,R) = \sum\limits_{i=L}^R (P[i]\text{ xor }X) is maximum possible. Lets see, if we take X = 0, value of G(L,R) will be equal to number of occurences of 1 in range (L,R). If we take X=1, value of G(L,R) will be equal to number of occurences of 0 in range (L,R). Hence, we can conclude that if the number of occurences of 1 is greater than or equal to number of occurences of 0 in range we will take X as 0 else we will take X as 1.

For each query, we just need to answer number of bits that are 1 at j^{th} bit in the range (L,R) for all 0 \le j < 31. For doing the same we will maintain prefix sum for each of the bit position. The pre-processing part can be done in O(N.log(MAX)). We can answer each of the query in O(log(MAX)) now, i.e. O(1) for each of the bit position. For more implementation details, you can have a look at attached solutions.

Time Complexity:

O((Q+N).log(MAX))

AUTHOR’S AND TESTER’S SOLUTIONS

Setter’s solution

Tester’s solution

4 Likes

What are the ways in which the pre-processing part can be done? Segment Tree?

1 Like

No, you do not need segment tree for preprocessing. Just use a prefix array.

python solution

2 Likes

You can do it by using 2D arrays @stym_06.

my c++ soln : CodeChef: Practical coding for everyone

My solution:

https://www.codechef.com/viewsolution/17820731

1 Like

Setter’s and Tester’s solution are not there and I am having trouble in understanding the approach used for this . Can someone explain an overview of what solution has been used in a less mathematical way ?
Thanks in advance :slight_smile:

Initially, we have to store set-bits of all numbers in a 2-D vector. Then take prefix sum of the 2-D vector.

Let assume that the query is from l to r index. For any jth bit , the numbers having it set are prefix[r][j] - prefix[l - 1][j]. The sole crux of the logic is to check whether (for any jth bit) numbers having that bit set are more or not. If numbers having jth bit set are more in query(l → r) , then we have to keep that bit unset in X. And in other way around, if numbers having that bit unset are more , then set that bit in X. If both are equal, keep it unset(question asks for smaller number).

link to my solution: CodeChef: Practical coding for everyone

hope it helps :slight_smile:

2 Likes

Segment tree solution
https://www.codechef.com/viewsolution/17804708

i used square root decomposition. whoever is interested can see

XXOR this problem can be done with the help of prefix sum of a 2D array into a another matrix of same size of [n][31].This a simple Question based on the basics of dynamic programming as u store the value and use it further by substracting to row let L & R.First you have to on all the 31 bit that is equal 2^31-1.Then you have to decide which bits should off according to maximize the ans as well as minimize the X.If anyone need soln. Then comment pliz.

Refer to my solution if you are a beginner.(Used comments for better understanding of code)

https://www.codechef.com/viewsolution/17848688

Thankyou @iprakhar22

2 Likes

@ayushgoyal1703
The link you provided won’t work for other people.
This is the link to your submission.

1 Like

Here is a simple java solution done by using 2D array of size n*31 for maintaining prefix sum for each of bit position.
Link to my solution: CodeChef: Practical coding for everyone

nice and clean implementation :stuck_out_tongue:

Where is your code’s link? :stuck_out_tongue:

thanks buddy got it now :stuck_out_tongue:

corrected now!!

https://www.codechef.com/viewsolution/17648523